proc	//your general/all purpose procs
	ListCheck(var/Object,var/List)	//look for Object in List
		if(Object in List)	return 1	//if found return 1
		else return 0	//otherwise return a 0
	RespawnWorld()	//this proc is called in World/New() in the Main.dm File
		world.Repop()	//this built in BYOND proc will respawn anything from runtime that was deleted
		//runtime is when the game is started (when the files are first run)
		//basicaly anything thats in the game when it first starts, excludes anything added during gameplay)
		spawn(600)	RespawnWorld()	//this will call the proc again after 60 seconds
		//because this proc calls itself it will loop for eternity! or at least until the game dies

mob/proc	//procs that can be ran on mobs
	LevelCheck()
		if(src.Exp>=src.Nexp)
			src<<"<I><B><small>You gained a level!"
			src.Level+=1
			src.MaxHP+=rand(1,5)	//the following lines give the player random stat boosts between 1 and 5
			src.MaxMP+=rand(1,5)
			src.Str+=rand(1,5)
			src.Def+=rand(1,5)
			src.HP=src.MaxHP	//restores HP and MP to max when gaining a level
			src.MP=src.MaxMP
			src.Exp=src.Exp-src.Nexp	//calculates exp so if you have 110 and only needed 100 u get to keep 10
			src.Nexp*=2	//multiples the required exp by 2 each level (be warned: gets really high really fast)
			for(var/obj/Skills/O in SkillList)	//runs through all the skills in the game
				if(O.LearnedBy==src.Class)	//only checks the ones your class can learn of course!
					if(O.LearnedOn==src.Level)	//if youre on the level u learn it on..
						src.contents+=new O.type	//then the player learns the skill!
						//contents is a built in list variable that can be used for inventories or the like
						src<<"<I><B><small>You learned [O]!"	//and lets give em a message about it
	DeathCheck(mob/Killer)
		if(src.HP<=0)
			if(src.key)	//if its a player you wana do something different right?
				src<<"<I><small>You were Killed by [Killer]!"	//a quick death message so u know u died
				src.HP=src.MaxHP	//restores users HP and MP after dying
				src.MP=src.MaxMP
				src.loc=locate(8,16,1)	//sends the dead guy back to the start
			else
				Killer<<"<I><small>You Killed a [src]! Gained [src.Exp] EXP and [src.Gold] Gold"
				Killer.Exp+=src.Exp
				Killer.Gold+=src.Gold
				Killer.LevelCheck()	//check if the player has enough EXP to level up
				del src	//this will simply delete the monster, no respawning


//The coding below it used to display names under players
//you could also run this proc on NPCs/Enemies if you wanted their names displayed
var/icon/ColorNPC='Alphabet.dmi'
obj/Supplemental/NameDisplay
	icon='Alphabet.dmi'
	layer=3
	pixel_y=-10
	New(var/px,var/IS)
		src.pixel_x=px+9
		src.icon_state=IS
atom/proc/AddName(var/Name2Add)
	var/spot=0
	var/letter=" "
	if(!Name2Add)	Name2Add=src.name
	for(var/O in src.overlays)
		if(O)	if(O:name=="NameDisplay")	src.overlays-=O
		else	src.overlays-=O
	while(letter!="")
		spot+=1
		letter=copytext(Name2Add,spot,spot+1)
		if(letter=="")	return
		var/px=(spot*6)-(length(Name2Add)*6)/2
		var/obj/Supplemental/NameDisplay/NL=new(px,letter)
		if(ColorNPC=='Alphabet.dmi')	ColorNPC+=rgb(0,120,200)
		if(istype(src,/mob/NPCs))	NL.icon+=ColorNPC
		src.overlays+=NL

var/list/CachedIcons=list()	//we'll use this to help reduce cpu usage from the rgb()ing of icons

//The Coding Below is Used for On-Screen Damage
obj
	Supplemental
		DamageNum
			icon='DamageNums.dmi'
			density=0
			layer=5	//keeps it above the players and enemies
			New(var/r,var/g,var/b)
				spawn(10) del src	//auto delete just in case!
				for(var/v in CachedIcons)	if(v=="Damage[r][g][b]")
					src.icon=CachedIcons[v];return
				src.icon+=rgb(r,g,b)
				CachedIcons+="Damage[r][g][b]"
				CachedIcons["Damage[r][g][b]"]=src.icon

mob/proc/DamageShow(var/damage,var/VarR=200,VarG=0,VarB=0)	//input the amount, then rgb values to change color
	if(istext(damage))	//if your send the proc something like Block it will display that instead of #s
		var/obj/O=new/obj/Supplemental/DamageNum	//creates the new object
		O.loc=locate(src:x,src:y,src:z)	//locates it at the damaged person
		flick("[damage]",O)	//this flashes the Block icon state, or whichever u sent
		return	//then return because we dont want to show numbers
	damage=min(999999,damage)	//999,999 is the highest number BYOND can accurately track
	damage=num2text(damage)	//this converts the number to text so we can chop it up
	var/pxplus=-7	//offsets the damage by -7 pixels
	var/spot=0	//used for cutting out the text
	while(pxplus<(length(damage)*7)-7)	//this makes it show itll only display a max of 7 numbers
		spot+=1	//determines where we're cutting
		pxplus+=7	//bump the pixel display by 7 each # so they dont overlap
		var/obj/Supplemental/DamageNum/O=new()	//create the new number
		O.pixel_x+=pxplus	//offset the numbers pixel display
		O.loc=locate(src:x,src:y,src:z)	//locate it at the person being hurt
		O.icon+=rgb(VarR,VarG,VarB)	//changes the color of the damage so we can use the same icon for healing, criticals, etc
		flick("[copytext(damage,spot,spot+1)]",O)	//this flashes the cut number of damage for this obj