obj/Skills
	var/LearnedBy	//defines variables for all skills
	var/LearnedOn
	var/MPCost
	Fire_Ball	//make a Fire Ball Skill
		LearnedBy="Magician"	//its learned by magicians!
		LearnedOn=2	//and they learn it on level 2
		MPCost=5	//costs 5 mp each cast!
		verb/Fire_Ball()	//this verb lets them use it
			set category="Skills"	//lets make this show up in a Skills Tab
			if(usr.BasicSkillUse(src))	//this runs the BasicSkillUse proc, which is coded below, and then checks what it returns
				var/damage=round(usr.MaxMP/2)	//lets make it do half your max MP as damage
				//using the built in round() proc will make we dont do decimal damage
				damage+=rand(-2,2)	//give or take a few to make it interesting
				usr.Projectile("[src.name]",damage)	//this is a proc i created, which is at the bottom of this file

	Strike	//should probably give each class at least 1 skill!
		LearnedBy="Warrior"
		LearnedOn=2
		MPCost=5
		verb/Strike()
			set category="Skills"
			if(usr.BasicSkillUse(src))
				var/damage=(usr.Str*2)+rand(-1,1)	//make this one do double their regular damage
				//as you can see you can put all calcs on 1 line, regular order of operations ensues!
				//make sure you use parentheses to guarentee correct calculations
				usr.DirectDamage("[src.name]",damage)	//this proc is below, itll do damage to stuff in front of u!
	Ninja_Star	//group skills for the same classes together for easier sorting and such
		LearnedBy="Warrior"
		LearnedOn=5	//dont get this one till level 5!
		//you could even set multiple skills on the same level, levelcheck proc will automaticaly learn them =)
		MPCost=7	//make it cost 7 or something...
		verb/Ninja_Star()
			set category="Skills"
			if(usr.BasicSkillUse(src))
				var/damage=usr.Str+rand(-1,1)	//this one will just do base damage
				usr.Projectile("[src.name]",damage)	//This way we can just use the same proc as in Fire Ball
				//without the need to recode it all over again
				//NEVER repeat any coding if you dont absolutely have to!

	Heal
		LearnedBy="Cleric"
		LearnedOn=2
		MPCost=5
		verb/Cast_Heal()	//this verb doesnt HAVE to match the skill's name, though it makes sense for it to match somewhat
			set category="Skills"
			if(usr.BasicSkillUse(src))
				usr.HealPlayer(usr,10)	//heal yourself for 10 HP, this proc is also below

mob/proc/BasicSkillUse(var/obj/Skills/S)	//since we do an MP check on all skills anyway, lets put it into a proc
	if(src.MP>=S.MPCost)	//checks if you have enough MP to use the skill
		src.MP-=S.MPCost	//take the MP from the user
		return 1	//return a 1 to let them use the skill
	else
		src<<"Not Enough MP!"
		return 0	//if they dont have enough MP dont let them use the skill


obj/Supplemental
	Projectile	//this will be modded to make up any projectile attacks!
		density=1	//make sure it can actualy hit stuff!
		var/mob/Owner	//somebody had to shoot it right?
		var/damage	//and we want it to actualy hurt stuff eh?
		icon='Projectiles.dmi'	//setup its icon
		New()
			spawn(100)	del src	//this will automaticaly delete it after 10 seconds, if its still around
		Bump(mob/M)
			if(ismob(M))
				if(src.Owner)	//make sure it has an owner! otherwise dont bother
					M.HP-=src.damage
					M.DamageShow(damage,200,0,0)	//flashes the damage on the screen
					M.DeathCheck(src.Owner)
			del src	//delete it after it hits something

mob/proc/Projectile(var/IS,var/damage)	//the arguments inside the () allow us to easily customize the proc
	//The Icon States for this proc are Kept in Projectiles.dmi
	//Simply add a new icon state and name it to match the skill and youre good to go!
	var/obj/Supplemental/Projectile/P=new()	//first we'll make a new projectile
	P.icon_state=IS	//this sets the icon state to whatever we need
	P.damage=damage	//this will set up the damage that we passed in through the arguments
	P.Owner=src	//set its owner to the person that shot it
	P.dir=src.dir	//make it face the same direction as the attacker
	P.loc=src.loc	//locate it on the player
	walk(P,src.dir)	//this will get P moving in the direction u shot it

mob/proc/DirectDamage(var/SkillName,var/damage)	//this proc works alot like the attack verb, except with a preset damage amount
	for(var/mob/Monster/M in get_step(src,src.dir))	//finds any monsters directly in front of the user
		M.HP-=damage	//subtract the damage from HP
		M.DamageShow(damage,200,0,0)	//flashes the damage on the screen
		M.DeathCheck(src)	//check if you killed the monster

mob/proc/HealPlayer(mob/M,var/heal)
	M.HP=min(M.MaxHP,M.HP+heal)	//add to their HP, but make sure it doesnt go over max
	M.DamageShow(heal,0,200,0)	//flashes the heal amount on screen, in a green color